/*
 * var.cc - a class for mathematical variables
 *
 */

#include <stdlib.h>
#include <iostream>
#include <assert.h>

#include "var.h"



int tmpvar = 0;



// Get the code number for variable c[i]

int var_num (char c, int i)
{
	assert (((c>='A' && c<='Z') || (c>='a' && c<='z')) && i>=0);
	if (c<'a') return (i<<6)+int(c-'A');
	else return (i<<6)+int(c-'a'+26);
}

void setnum (var& v, int n) {v.number = n;};
int getnum (const var& v) {return v.number;};



// Comparison

bool operator== (const var& v, const var& w) {return v.number == w.number;};
bool operator!= (const var& v, const var& w) {return v.number != w.number;};



// Print a variable to an output stream

ostream& operator<< (ostream& os, const var& v)
{
	int n = v.number;
	char c;

	if (n<0) os << "#[" << -n << "]";
	else {
		c = char (n & 63);
		if (c<26) c+='A';
		else c+='a'-26;
		cout << c;
		n>>=6;
		if (n) cout << "[" << n << "]";
	};

	return os;
}



// Read a variable from an input stream

istream& operator>> (istream& is, var& v)
{
	char c,d;
	int n = 0;

	is >> c;
	if (!is || c<'A' || c>'z' || (c>'Z' && c<'a')) goto BAD;

	if (!is.eof ()) { // check for index
		d = is.get ();
		if (!is) goto BAD;
		if (d=='[') {
			is >> n;
			if (!is || n<0) goto BAD;
			d = is.get ();
			if (!is || d!=']') goto BAD;
		} else is.unget ();
	}

	v = var (c,n);

	return is;

BAD:	is.clear ( ios::badbit | is.rdstate () );
	return is;
}



// Database functions

void set_key (database& db, const var& v) {set_key (db, v.number);};
void set_value (database& db, const var& v) {set_value (db, v.number);};
bool get_value (database& db, var& v) {return get_value (db, v.number);};

